    BSIP: 0039
    Title: Automatically approve proposals by the proposer
    Authors: Fabian Schuh <https://github.com/xeroc>
             Abit More <https://github.com/abitmore>
    Status: Draft
    Type: Protocol
    Created: 2018-03-20
    Discussion: https://github.com/bitshares/bitshares-core/issues/138
    Worker: <Id of worker proposal>

# Abstract

On the BitShares Blockchain, proposals allow to gather signatures for a
multisignature-setup by means of on-chain approvals. In contrast to
other blockchains, these proposals are actually stored on the blockchain
and automatically executed once the required amount of approvals has
been reached. This allows participants of a multisignature-setup to
exchange insufficiently signed transactions easily.

However, when creating a new proposal, the proposer needs to manually
approve his operation afterwards. This is not only inconvenient, but
also costs and additional operation and thus a fee.

This BSIP recommends to have the proposer of a proposal automatically
added as approved.

# Motivation

In the case of a simple 2-of-3 multisig-scheme, today's implementation
forces us to have 3 operations stored on the blockchain: a) the proposal
itself, and two approvals.

The inconvenience and additional fee hinders adoption of this scheme and
makes it unnecessary complicated.

# Rational

By proposing an action, the proposer can be considered as an agreeing
party, otherwise the proposal wouldn't have been created in the first
place.

If the proposer is not part of the multisig-setup, having him approve
the proposal automatically does affect the validity of the proposal
itself.

# Specifications

This BSIP comes with only minimal modifications that, however, change
the behavior of the protocol and thus need a protocol upgrade.

The change is implemented in such a way that the `fee_paying_account`
for the proposal is added to the `available_active_approvals` of the
proposal after creation.

# Discussion

To be found in the forum - see link above.

# Summary for Shareholders

This BSIP proposes a minor modification that improves the process of
using hierarchical account permissions and simplifies the use of
multisig-setups with only minimal modifications.

# Copyright

This document is placed in the public domain.

# See Also

* https://github.com/bitshares/bitshares-core/issues/138
